Foreman - Bug #33240

Facts import after code change in DEV environment don't work
08/11/2021 10:58 AM - Leos Stejskal

Status: Resolved
Priority: Normal
Assignee: Adi Abramovitch
Category: Facts
Target version:
Difficulty: Fixed in Releases:
Triaged: Yes Found in Releases: Nightly
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/8027
Description

Change in the code while in DEV environment cause error during fact import, the only fix is restart.
Steps to reproduce

e Generate registration command (Hosts > Register Host) and register CentOS machine
¢ Do some change in the code (for example add comment somewhere in controller classes)
e Try to register host again (with --force parameter)

Error

2021-08-11T10:53:05 [I|app|80d9e34e] Import facts for 'stream.example.com'

completed. Added: 156,

Updated: 0, Deleted 0 facts
2021-08-11T10:53:05 [E|kat|80d9e34e] NoMethodError: undefined method ‘new' for nil:NilClass
80d9e34e | /home/vagrant/foreman/app/services/host_fact_importer.rb:47:in “block in parse_facts'
80d9e34e | /home/vagrant/foreman/app/services/host_fact_importer.rb:90:in “block in skipping_orch
estration'
80d9e34e | /home/vagrant/foreman/app/models/concerns/orchestration.rb:124:1in
"without_orchestration'
80d9%e34e | /home/vagrant/foreman/app/services/host_fact_importer.rb:89:in " skipping_orchestration
80d9e34e | /home/vagrant/foreman/app/services/host_fact_importer.rb:45:in ‘parse_facts'
80d9e34e | /home/vagrant/foreman/app/services/host_fact_importer.rb:34:in " import_facts'
80d9e34e | /home/vagrant/foreman/app/models/host/base.rb:143:in "~ import_facts'
80d9e34e | /home/vagrant/katello/app/models/katello/host/subscription_facet.rb:220:in ‘update_fac
ts'
80d9%e34e | /home/vagrant/katello/app/services/katello/registration_manager.rb:217:in

‘create_in_candlepin'

80d9e34e | /home/vagrant/katello/app/services/katello/registration_manager.rb:171:in “block in
register_host'

80d9e34e | /home/vagrant/foreman/app/models/concerns/foreman/thread_session.rb:108:in “as'
80d9e34e | /home/vagrant/foreman/app/models/concerns/foreman/thread_session.rb:114:1in
‘as_anonymous_admin'

80d9e34e | /home/vagrant/katello/app/services/katello/registration_manager.rb:169:1in
register_host'

80d9%e34e | /home/vagrant/katello/app/services/katello/registration_manager.rb:40:in "“process_regi
stration'

80d9e34e | /home/vagrant/katello/app/controllers/katello/api/rhsm/candlepin_proxies_controller.rb
:234:1in " consumer_activate'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_controller
/metal/basic_implicit_render.rb:6:in "“send_action'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/abstract_controll
er/base.rb:195:in "process_action'

80d%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_controller
/metal/rendering.rb:30:1in ‘process_action'
80d9%e34e |
er/callbacks.rb:42:in “block in process_action'
80d9%e34e |
/callbacks.rb:112:in
80d9%e34e |
:35:1in " repackage_message'
80d9e34e |
/callbacks.rb:121:in
80d9%e34e |
et_timezone'
80d9%e34e |
/callbacks.rb:121:in
80d9%e34e |
clear_thread'
80d9e34e |
/callbacks.rb:121:1in
80d9%e34e |
:in “set_topbar_sweeper_controller'
80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.
/callbacks.rb:121:in “block in run_callbacks'

"block in run_callbacks'

“block in run_callbacks'

"block in run_callbacks'

“block in run_callbacks'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
:in “around’
80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.

/callbacks.rb:121:in “block in run_callbacks'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
:in “around'
80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.

/callbacks.rb:121:in
80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
/callbacks.rb:139:in
80d9e34e |
er/callbacks.rb:41:in "process_action'
80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
/metal/rescue.rb:22:in ‘process_action'
80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.

"block in run_callbacks'

“run_callbacks'
/home/vagrant/foreman/.vendor/ruby/2.

7

7

/home/vagrant/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:1in

/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/abstract_controll
/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1ib/active_support
/home/vagrant/katello/app/controllers/katello/api/rhsm/candlepin_proxies_controller.rb

/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1ib/active_support

's

/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1ib/active_support
/home/vagrant/foreman/app/models/concerns/foreman/thread_session.rb:32:1in
/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1lib/active_support

/home/vagrant/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12

.0/gems/activesupport-6.0.3.7/1lib/active_support

.0/gems/audited-4.10.

0/lib/audited/sweeper.rb:14

.0/gems/activesupport-6.0.3.7/1lib/active_support

.0/gems/audited-4.10.

0/lib/audited/sweeper.rb:14

.0/gems/activesupport-6.0.3.7/1lib/active_support

.0/gems/activesupport-6.0.3.7/1lib/active_support

.0/gems/actionpack-6.
.0/gems/actionpack-6.

.0/gems/actionpack-6.

/metal/instrumentation.rb:33:in “block in process_action'

80d9%e34e |
/notifications.rb:180:in
80d9e34e |
/notifications/instrumenter.rb:24:in
80d9%e34e |
/notifications.rb:180:1in
80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.
/metal/instrumentation.rb:32:in ‘process_action'
80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
/metal/params_wrapper.rb:245:in ‘process_action'
80d9e34e |

“block in instrument'
“instrument'

“instrument'

/home/vagrant/foreman/.vendor/ruby/2

/home/vagrant/foreman/.vendor/ruby/2.7.

/home/vagrant/foreman/.vendor/ruby/2.7.

.0/gems/actionpack-6.

.0/gems/actionpack-6.

railties/controller_runtime.rb:27:in " process_action'

80d9%e34e |
process_action'

80d9%e34e | /home/vagrant/foreman/.
er/base.rb:136:in “process'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
rendering.rb:39:in “process'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
/metal.rb:190:in “dispatch’'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
/metal.rb:254:in “dispatch'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.
routing/route_set.rb:50:in “dispatch'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.
outing/route_set.rb:33:in "serve'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.

7

vendor/ruby/2.7.0/gems/actionpack-6.

.0/gems/actionview-6.
.0/gems/actionpack-6.
.0/gems/actionpack-6.
.0/gems/actionpack-6.
.0/gems/actionpack-6.

.0/gems/actionpack-6.

outing/mapper.rb:18:in ‘block in <class:Constraints>'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.
routing/mapper.rb:48:in "serve'
80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.
0.3.7/1lib/abstract_controll
0.3.7/l1lib/action_controller

0.3.7/1lib/action_controller

/home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1lib/active_support
0/gems/activesupport-6.0.3.7/1lib/active_support

0/gems/activesupport-6.0.3.7/1ib/active_support

0.3.7/1lib/action_controller

0.3.7/1lib/action_controller

.7.0/gems/activerecord-6.0.3.7/1lib/active_record/

/home/vagrant /katello/app/controllers/katello/concerns/api/api_controller.rb:50:in

0.3.7/1lib/abstract_controll
0.3.7/1lib/action_view/
.7/1lib/action_controller
.7/1lib/action_controller
.7/lib/action_dispatch/
.7/1lib/action_dispatch/r
.7/1lib/action_dispatch/r
.7/1lib/action_dispatch/

.7/1lib/action_dispatch/j
ourney/router.rb:49:in ‘block in serve'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/j
ourney/router.rb:32:in “each'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
journey/router.rb:32:in "serve'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/r
outing/route_set.rb:834:in ‘call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/engine.rb:527
:in “call!

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/railtie.rb:
190:in "public_send'

80d%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/railtie.rb:19
0:in "method_missing'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/r
outing/mapper.rb:19:in ‘block in <class:Constraints>'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
routing/mapper.rb:48:in " serve'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/j
ourney/router.rb:49:in ‘block in serve'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/j
ourney/router.rb:32:in ‘each'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
journey/router.rb:32:in "serve'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/r
outing/route_set.rb:834:in ‘call'

80d9e34e | /home/vagrant/katello/lib/katello/middleware/organization_created_enforcer.rb:18:in "¢
all'

80d9e34e | /home/vagrant/katello/lib/katello/middleware/event_daemon.rb:10:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1ib/action_dispatch/m
iddleware/static.rb:126:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1ib/action_dispatch/m
iddleware/static.rb:126:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/apipie-dsl-2.4.0/1ib/apipie_dsl/
static_dispatcher.rb:67:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/apipie-rails-0.5.19/1ib/apipie/static_di
spatcher.rb:66:in “call’

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/bullet-6.1.4/1ib/bullet/rack.rb:15:in “c
all'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/apipie-rails-0.5.19/1ib/apipie/extractor
/recorder.rb:137:in ‘call'

80d9e34e | /home/vagrant/foreman/lib/foreman/middleware/telemetry.rb:10:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/apipie-rails-0.5.19/1ib/apipie/middlewar
e/checksum_in_headers.rb:27:in “call'

80d9e34e | /home/vagrant/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-openid-1.4.2/1ib/rack/openid.rb:98:
in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/tempfile_reaper.rb:1l
5:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/etag.rb:27:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/conditional_get.rb:4
O:in “call'

80d%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack—-2.2.3/1lib/rack/head.rb:12:in “call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
http/content_security_policy.rb:18:in “call'

80d9e34e | /home/vagrant/foreman/lib/foreman/middleware/logging_context_session.rb:22:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/session/abstract/id.
rb:266:in "context'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/session/abstract/id.
rb:260:in “call’

80d%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/cookies.rb:648:in ‘call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activerecord-6.0.3.7/1lib/active_record/m
igration.rb:567:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
middleware/callbacks.rb:27:in “block in call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1lib/active_support
/callbacks.rb:101:in “run_callbacks'
80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/callbacks.rb:26:in “call'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack—-6.0.3.7/1ib/action_dispatch/
middleware/executor.rb:14:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/actionable_exceptions.rb:18:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/debug_exceptions.rb:32:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
middleware/show_exceptions.rb:33:in “call'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1ib/rails/rack/logger.r
b:37:in ‘call_app'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1ib/rails/rack/logger.r
b:28:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/sprockets-rails-3.2.2/1ib/sprockets/
rails/quiet_assets.rb:13:in “call'

80d9e34e | /home/vagrant/foreman/lib/foreman/middleware/logging_context_request.rb:11l:in “call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/remote_ip.rb:81l:in “call'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
middleware/request_id.rb:27:in ‘call'

80d9%e34e | /home/vagrant/katello/lib/katello/prevent_json_parsing.rb:12:in ‘call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/method_override.rb:2
4:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/runtime.rb:22:1in
‘call!

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/activesupport-6.0.3.7/1lib/active_support
/cache/strategy/local_cache_middleware.rb:29:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1ib/action_dispatch/m
iddleware/executor.rb:14:in ‘call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/
middleware/static.rb:126:in ‘call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/sendfile.rb:110:1in
call"

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/actionpack-6.0.3.7/1lib/action_dispatch/m
iddleware/host_authorization.rb:82:in “call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/secure_headers-6.3.2/1ib/secure_headers/
middleware.rb:11:in “call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/engine.rb:527
:in “call!

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/railtie.rb:19
0:in "public_send'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/railties-6.0.3.7/1lib/rails/railtie.rb:
190:in “method_missing'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/urlmap.rb:74:1in
block in call'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/urlmap.rb:58:in "eac
hl

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/rack-2.2.3/1lib/rack/urlmap.rb:58:1in
‘call!

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1ib/puma/configuration.rb:249
:in “call’

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1lib/puma/request.rb:77:in bl
ock in handle_request'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1ib/puma/thread_pool.rb:340
:in “with_force_shutdown'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1lib/puma/request.rb:76:1in
handle_request'

80d9%e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1lib/puma/server.rb:440:in “pr
ocess_client'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/puma-5.4.0/1ib/puma/thread_pool.rb:147
:in "block in spawn_thread'

80d9e34e | /home/vagrant/foreman/.vendor/ruby/2.7.0/gems/logging-2.3.0/1ib/logging/diagnostic_con
text.rb:474:in "block in create_with_logging_context'

2021-08-11T10:53:05 [I|app|80d9e34e] Completed 500 Internal Server Error in 4647ms (Views: 0.3ms |
ActiveRecord: 439.8ms | Allocations: 512389)

80d9%e34e |
80d9e34e |
2021-08-11T10:53:05 [D|app|80d9e34e] With body: {"displayMessage":"undefined method “new' for nil
:NilClass", "errors": ["undefined method "new' for nil:NilClass"]}

80d9%e34e |

History

#1 - 09/06/2021 01:28 PM - Amit Upadhye
- Target version changed from 3.0.0 to 3.0.1

#2 - 10/19/2021 09:13 AM - Tomer Brisker
- Target version deleted (3.0.1)

Removing target version as this only affects development.

#3 - 12/14/2021 06:31 PM - Adi Abramovitch

- Assignee set to Adi Abramovitch

#4 - 12/20/2021 11:45 AM - Adi Abramovitch
- Status changed from New to Resolved

- Pull request https://github.com/theforeman/foreman/pull/8027 added
